diff -EbwBru 6.0.0.M1/org/jboss/mx/loading/RepositoryClassLoader.java trunk/org/jboss/mx/loading/RepositoryClassLoader.java
--- 6.0.0.M1/org/jboss/mx/loading/RepositoryClassLoader.java	2009-11-30 14:31:25.000000000 -0600
+++ trunk/org/jboss/mx/loading/RepositoryClassLoader.java	2009-12-10 12:42:46.000000000 -0600
@@ -37,8 +37,10 @@
 import java.util.Vector;
 import java.util.Collections;
 import java.util.Set;
+import java.util.concurrent.ConcurrentHashMap;
+import java.util.concurrent.TimeUnit;
+import java.util.concurrent.locks.ReentrantLock;
 
-import javax.management.MalformedObjectNameException;
 import javax.management.ObjectName;
 
 import org.jboss.classloading.spi.RealClassLoader;
@@ -46,14 +48,11 @@
 import org.jboss.util.loading.Translator;
 import org.jboss.util.collection.SoftSet;
 
-import EDU.oswego.cs.dl.util.concurrent.ReentrantLock;
-import EDU.oswego.cs.dl.util.concurrent.ConcurrentReaderHashMap;
-
 /**
  * A RepositoryClassLoader.
  * 
  * @author <a href="adrian@jboss.com">Adrian Brock</a>
- * @version $Revision: 81019 $
+ * @version $Revision: 86129 $
  */
 public abstract class RepositoryClassLoader extends URLClassLoader implements RealClassLoader
 {
@@ -79,11 +78,12 @@
    protected ClassLoader parent = null;
    
    /** Names of classes which have resulted in CNFEs in loadClassLocally */
-   private Set classBlackList = Collections.synchronizedSet(new SoftSet());
+   @SuppressWarnings("unchecked")
+   private Set<String> classBlackList = Collections.synchronizedSet(new SoftSet());
    /** Names of resources that were not found in loadResourceLocally */
-   private Set resourceBlackList = Collections.synchronizedSet(new HashSet());
+   private Set<String> resourceBlackList = Collections.synchronizedSet(new HashSet<String>());
    /** A HashMap<String, URL> for resource found in loadResourceLocally */
-   private ConcurrentReaderHashMap resourceCache = new ConcurrentReaderHashMap();
+   private ConcurrentHashMap<String, URL> resourceCache = new ConcurrentHashMap<String, URL>();
    
    /** Lock */
    protected ReentrantLock loadLock = new ReentrantLock();
@@ -101,6 +101,7 @@
     * @param urls the urls
     * @param parent the parent classloader
     */
+   @SuppressWarnings("unchecked")
    protected RepositoryClassLoader(URL[] urls, ClassLoader parent)
    {
       super(urls, parent);
@@ -109,8 +110,8 @@
       String mode = ClassToStringAction.getProperty("org.jboss.mx.loading.blacklistMode", null);
       if( mode == null || mode.equalsIgnoreCase("HashSet") )
       {
-         classBlackList = Collections.synchronizedSet(new HashSet());
-         resourceBlackList = Collections.synchronizedSet(new HashSet());
+         classBlackList = Collections.synchronizedSet(new HashSet<String>());
+         resourceBlackList = Collections.synchronizedSet(new HashSet<String>());
       }
       else if( mode.equalsIgnoreCase("SoftSet") )
       {
@@ -135,6 +136,8 @@
    
    /**
     * Get the loader repository for this classloader
+    * 
+    * @return the loader repository
     */
    public LoaderRepository getLoaderRepository()
    {
@@ -191,10 +194,7 @@
       this.addedOrder = addedOrder;
    }
 
-   /** 
-    * Called to attempt to load a class from the set of URLs associated with this classloader.
-    */
-   public Class loadClassLocally(String name, boolean resolve)
+   public Class<?> loadClassLocally(String name, boolean resolve)
       throws ClassNotFoundException
    {
       boolean trace = log.isTraceEnabled();
@@ -203,7 +203,7 @@
       if( name == null || name.length() == 0 )
          throw new ClassNotFoundException("Null or empty class name");
 
-      Class result = null;
+      Class<?> result = null;
       try
       {
          if (isClassBlackListed(name))
@@ -252,12 +252,12 @@
       }
    }
 
-   /**
+   /*
    * Provides the same functionality as {@link java.net.URLClassLoader#getResource}.
    */
    public URL getResourceLocally(String name)
    {
-      URL resURL = (URL) resourceCache.get(name);
+      URL resURL = resourceCache.get(name);
       if (resURL != null)
          return resURL;
       if (isResourceBlackListed(name))
@@ -312,6 +312,7 @@
     * Return all library URLs associated with this RepositoryClassLoader
     *
     * <p>Do not remove this method without running the WebIntegrationTestSuite
+    * @return the urls
     */
    public URL[] getAllURLs()
    {
@@ -415,13 +416,13 @@
    *
    * <p>Forwards request to {@link LoaderRepository}.
    */
-   public Class loadClass(String name, boolean resolve)
+   public Class<?> loadClass(String name, boolean resolve)
       throws ClassNotFoundException
    {
       boolean trace = log.isTraceEnabled();
       if (trace)
          log.trace("loadClass " + this + " name=" + name+", loadClassDepth="+loadClassDepth);
-      Class clazz = null;
+      Class<?> clazz = null;
       try
       {
          if (repository != null)
@@ -459,14 +460,17 @@
    * load the class.
    *
    * <p>Forwards request to {@link LoaderRepository}.
+   * @param name the class name
+   * @return the class
+   * @throws ClassNotFoundException when the class is not found
    */
-   public Class loadClassBefore(String name)
+   public Class<?> loadClassBefore(String name)
       throws ClassNotFoundException
    {
       boolean trace = log.isTraceEnabled();
       if (trace)
          log.trace("loadClassBefore " + this + " name=" + name);
-      Class clazz = null;
+      Class<?> clazz = null;
       try
       {
          clazz = loadClassImpl(name, false, addedOrder);
@@ -484,7 +488,7 @@
       }
    }
 
-   public abstract Class loadClassImpl(String name, boolean resolve, int stopAt)
+   public abstract Class<?> loadClassImpl(String name, boolean resolve, int stopAt)
       throws ClassNotFoundException;
 
    /**
@@ -505,9 +509,9 @@
     * @return Enumeration<URL>
     * @throws java.io.IOException
     */
-   public Enumeration findResources(String name) throws IOException
+   public Enumeration<URL> findResources(String name) throws IOException
    {
-      Vector resURLs = new Vector();
+      Vector<URL> resURLs = new Vector<URL>();
       if( repository == null )
       {
          String msg = "Invalid use of destroyed classloader, UCL destroyed at:";
@@ -521,8 +525,12 @@
 
    /**
    * Provides the same functionality as {@link java.net.URLClassLoader#findResources}.
+   * 
+   * @param name the resource name
+   * @return the found resources
+   * @throws IOException for an error accessing the resources
    */
-   public Enumeration findResourcesLocally(String name) throws IOException
+   public Enumeration<URL> findResourcesLocally(String name) throws IOException
    {
       return super.findResources(name);
    }
@@ -534,7 +542,7 @@
      * @return the resulting class
      * @exception ClassNotFoundException if the class could not be found
      */
-   protected Class findClass(String name) throws ClassNotFoundException
+   protected Class<?> findClass(String name) throws ClassNotFoundException
    {
       boolean trace = log.isTraceEnabled();
       if( trace )
@@ -582,7 +590,7 @@
          }
       }
 
-      Class clazz = null;
+      Class<?> clazz = null;
       try
       {
          clazz = findClassLocally(name);
@@ -602,8 +610,9 @@
     * 
     * @param name the name of the class
     * @return the class
+    * @throws ClassNotFoundException when the class is not found
     */
-   protected Class findClassLocally(String name) throws ClassNotFoundException
+   protected Class<?> findClassLocally(String name) throws ClassNotFoundException
    {
       return super.findClass(name);
    }
@@ -725,6 +734,9 @@
     * before a thread enters the class loading task loop in loadClass. This
     * method maintains any interrupted state of the calling thread.
     *@see #loadClass(String, boolean)
+    *
+    * @param waitMS the length of time to wait in milliseconds
+    * @return true when the lock was obtained
     */
    protected boolean attempt(long waitMS)
    {
@@ -734,7 +746,7 @@
       boolean threadWasInterrupted = Thread.interrupted();
       try
       {
-         acquired = loadLock.attempt(waitMS);
+         acquired = loadLock.tryLock(waitMS, TimeUnit.MILLISECONDS);
       }
       catch(InterruptedException e)
       {
@@ -746,7 +758,7 @@
             Thread.currentThread().interrupt();
       }
       if( trace )
-         log.trace("attempt("+loadLock.holds()+") was: "+acquired+" for :"+this);
+         log.trace("attempt("+loadLock.getHoldCount()+") was: "+acquired+" for :"+this);
       return acquired;
    }
    
@@ -756,23 +768,9 @@
     */
    protected void acquire()
    {
-      // Save and clear the interrupted state of the incoming thread
-      boolean threadWasInterrupted = Thread.interrupted();
-      try
-      {
-         loadLock.acquire();
-      }
-      catch(InterruptedException e)
-      {
-      }
-      finally
-      {
-         // Restore the interrupted state of the thread
-         if( threadWasInterrupted )
-            Thread.currentThread().interrupt();
-      }
+      loadLock.lock();
       if( log.isTraceEnabled() )
-         log.trace("acquired("+loadLock.holds()+") for :"+this);
+         log.trace("acquired("+loadLock.getHoldCount()+") for :"+this);
    }
    /** Release the class loading lock previous acquired through the acquire
     * method.
@@ -780,10 +778,10 @@
    protected void release()
    {
       if( log.isTraceEnabled() )
-         log.trace("release("+loadLock.holds()+") for :"+this);
-      loadLock.release();
+         log.trace("release("+loadLock.getHoldCount()+") for :"+this);
+      loadLock.unlock();
       if( log.isTraceEnabled() )
-         log.trace("released, holds: "+loadLock.holds());
+         log.trace("released, holds: "+loadLock.getHoldCount());
    }
 
    /** Obtain the bytecode for the indicated class from this class loaders
@@ -793,6 +791,7 @@
     * @return the bytecode array if found
     * @exception ClassNotFoundException - if the class resource could not
     *    be found
+    * @throws IOException when there is an error loading the class bytes
     */ 
    protected byte[] loadByteCode(String classname)
       throws ClassNotFoundException, IOException
@@ -830,6 +829,7 @@
     * @return the bytecode array if found
     * @exception ClassNotFoundException - if the class resource could not
     *    be found
+    * @throws IOException when there is an error loading the class bytes
     */
    protected byte[] loadByteCode(URL classURL)
       throws ClassNotFoundException, IOException
@@ -861,6 +861,8 @@
    /**
     * Determine the protection domain. If we are a copy of the original
     * deployment, use the original url as the codebase.
+    * 
+    * @param codesourceUrl the codesource url
     * @return the protection domain
     * @todo certificates and principles?
     */
diff -EbwBru 6.0.0.M1/org/jboss/mx/loading/UnifiedClassLoader.java trunk/org/jboss/mx/loading/UnifiedClassLoader.java
--- 6.0.0.M1/org/jboss/mx/loading/UnifiedClassLoader.java	2009-11-30 14:38:49.000000000 -0600
+++ trunk/org/jboss/mx/loading/UnifiedClassLoader.java	2009-12-10 12:42:46.000000000 -0600
@@ -53,7 +53,7 @@
 * @author <a href="scott.stark@jboss.org">Scott Stark</a>
 * @author <a href="juha@jboss.org">Juha Lindfors</a>
 * @author <a href="bill@jboss.org">Bill Burke</a>
-* @version <tt>$Revision: 81022 $</tt>
+* @version <tt>$Revision: 85671 $</tt>
 */
 public class UnifiedClassLoader extends RepositoryClassLoader
    implements UnifiedClassLoaderMBean, Translatable
@@ -207,13 +207,15 @@
    }
    
    /** Get the original URL associated with the UCL. This may be null.
+    * 
+    * @return the url
     */
    public URL getOrigURL()
    {
       return origURL;
    }
    
-   public synchronized Class loadClassImpl(String name, boolean resolve, int stopAt)
+   public synchronized Class<?> loadClassImpl(String name, boolean resolve, int stopAt)
       throws ClassNotFoundException
    {
       loadClassDepth ++;
@@ -278,7 +280,7 @@
       {
          Thread t = Thread.currentThread();
          // Register this thread as owning this UCL
-         if( loadLock.holds() == 1 )
+         if( loadLock.getHoldCount() == 1 )
             LoadMgr3.registerLoaderThread(this, t);
 
          // Create a class loading task and submit it to the repository
@@ -306,7 +308,7 @@
       finally
       {
          // Unregister as the UCL owner to reschedule any remaining load tasks
-         if( loadLock.holds() == 1 )
+         if( loadLock.getHoldCount() == 1 )
             LoadMgr3.endLoadTask(task);
          // Notify any threads waiting to use this UCL
          this.release();
@@ -364,12 +366,12 @@
       PermissionCollection perms = super.getPermissions(permCS);
       PermissionCollection perms2 = super.getPermissions(cs);
       PermissionCollection perms3 = policy.getPermissions(permCS);
-      Enumeration iter = perms2.elements();
+      Enumeration<Permission> iter = perms2.elements();
       while( iter.hasMoreElements() )
-         perms.add((Permission) iter.nextElement());
+         perms.add(iter.nextElement());
       iter = perms3.elements();
       while( iter.hasMoreElements() )
-         perms.add((Permission) iter.nextElement());
+         perms.add(iter.nextElement());
       if( log.isTraceEnabled() )
          log.trace("getPermissions, url="+url+", origURL="+origURL+" -> "+perms);
       return perms;
